#ifndef GMCPPSDK_H
#define GMCPPSDK_H

#include <iostream>
#include "gmdef.h"

#ifdef WIN32
#ifdef GMSDKC_EXPORTS  
#define GM_CXX_API __declspec(dllexport)
#else
#define GM_CXX_API __declspec(dllimport)
#endif
#else
#define GM_CXX_API
#endif

//
class DataSet
{
public:
	//ȡapiý, 0: ɹ 0: 
	virtual int status() = 0;

	//жǷѾǵĩβ
	virtual bool is_end() = 0;

	//Ƶһ¼
	virtual void next() = 0;

	//ȡֵ
	virtual int get_integer(const char *key) = 0;

	//ȡֵ
	virtual long long get_long_integer(const char *key) = 0;

	//ȡֵ
	virtual double get_real(const char *key) = 0;

	//ȡֵַ
	virtual const char* get_string(const char *key) = 0;

	//ͷݼ
	virtual void release() = 0;

	//ӡ
	virtual const char* debug_string() = 0;
};

//
template <typename T>
class DataArray
{
public:
	//ȡapiý, 0: ɹ 0: 
	virtual int status() = 0;

	//ؽṹָ
	virtual T* data() = 0;

	//ݵĳ
	virtual int count() = 0;

	//±ΪiĽṹã0ʼ
	virtual T& at(int i) = 0;

	//ͷݼ
	virtual void release() = 0;
};

// ȡsdk汾
GM_CXX_API const char* get_version();

// token
GM_CXX_API void set_token(const char *token);

// Զַ
GM_CXX_API void set_serv_addr(const char *addr);

// ѯǰ
GM_CXX_API DataArray<Tick>* current(const char *symbols);

// ѯʷTick
GM_CXX_API DataArray<Tick>* history_ticks(const char *symbols, const char *start_time, const char *end_time, int adjust = 0, const char *adjust_end_time = NULL, bool skip_suspended = true, const char *fill_missing = NULL);

// ѯʷBar
GM_CXX_API DataArray<Bar>* history_bars(const char *symbols, const char *frequency, const char *start_time, const char *end_time, int adjust = 0, const char *adjust_end_time = NULL, bool skip_suspended = true, const char *fill_missing = NULL);

// ѯnTick
GM_CXX_API DataArray<Tick>* history_ticks_n(const char *symbols, int n, const char *end_time = NULL, int adjust = 0, const char *adjust_end_time = NULL, bool skip_suspended = true, const char *fill_missing = NULL);

//ѯnBar
GM_CXX_API DataArray<Bar>* history_bars_n(const char *symbols, const char *frequency, int n, const char *end_time = NULL, int adjust = 0, const char *adjust_end_time = NULL, bool skip_suspended = true, const char *fill_missing = NULL);

// ѯʷL2 Tick
GM_CXX_API DataArray<Tick>* history_ticks_l2(const char *symbols, const char *start_time, const char *end_time, int adjust = 0, const char *adjust_end_time = NULL, bool skip_suspended = true, const char *fill_missing = NULL);

// ѯʷL2 Bar
GM_CXX_API DataArray<Bar>* history_bars_l2(const char *symbols, const char *frequency, const char *start_time, const char *end_time, int adjust = 0, const char *adjust_end_time = NULL, bool skip_suspended = true, const char *fill_missing = NULL);

// ѯʷL2 Transaction
GM_CXX_API DataArray<L2Transaction>* history_transaction_l2(const char *symbols, const char *start_time, const char *end_time);

// ѯ
GM_CXX_API DataSet* get_fundamentals(const char *table, const char *symbols, const char *start_date, const char *end_date, const char *fields, const char *filter = NULL, const char *order_by = NULL, int limit = 1000);

// ѯn
GM_CXX_API DataSet* get_fundamentals_n(const char *table, const char *symbols, const char *end_date, const char *fields, int n = 1, const char *filter = NULL, const char * order_by = NULL);

// ѯ½ױϢ
GM_CXX_API DataSet* get_instruments(const char *exchanges = NULL, const char *sec_types = NULL, const char* fields = NULL);

// ѯױʷ
GM_CXX_API DataSet* get_history_instruments(const char *symbols, const char *start_date, const char *end_date, const char *fields = NULL);

// ѯױĻϢ
GM_CXX_API DataSet* get_instrumentinfos(const char *symbols = NULL, const char *exchanges = NULL, const char * sec_types = NULL, const char *names = NULL, const char *fields = NULL);

// ѯָɷݹ
GM_CXX_API DataSet* get_constituents(const char *index, const char *trade_date = NULL);

// ѯҵƱб
GM_CXX_API DataArray<Symbol>* get_industry(const char *code);

// ѯƱб
GM_CXX_API DataArray<Symbol>* get_concept(const char *code);

// ѯб
GM_CXX_API DataArray<TradingDate>* get_trading_dates(const char *exchange, const char *start_date, const char *end_date);

// ָڵһ
GM_CXX_API int get_previous_trading_date(const char *exchange, const char *date, char *output_date);

// ָڵһ
GM_CXX_API int get_next_trading_date(const char *exchange, const char *date, char *output_date);

// ѯֺ
GM_CXX_API DataSet* get_dividend(const char *symbol, const char *start_date, const char *end_date);

// ȡԼ
GM_CXX_API DataSet* get_continuous_contracts(const char *csymbol, const char *start_date, const char *end_date);


#endif
