#ifndef GMCSDK_DEF_H
#define GMCSDK_DEF_H


const unsigned int LEN_ID = 64;
const unsigned int LEN_NAME = 64;
const unsigned int LEN_SYMBOL = 32;
const unsigned int LEN_INFO = 128;
const unsigned int LEN_EXCHANGE = 8;
const unsigned int LEN_ISO_DATATIME = 36;
const unsigned int LEN_FREQUENCY = 8;
const unsigned int DEPTH_OF_QUOTE = 10;
const unsigned int LEN_PARAM = 256;
const unsigned int LEN_COMMENT = 256;

enum StrategyMode
{
	MODE_UNDEF = 0,          //δ壬 Բ
	MODE_LIVE = 1,           //ʵģʽ
	MODE_BACKTEST = 2        //زģʽ
};

enum OrderStatus
{
	OrderStatus_Unknown = 0,
	OrderStatus_New = 1,                   //ѱ
	OrderStatus_PartiallyFilled = 2,       //
	OrderStatus_Filled = 3,                //ѳ
	OrderStatus_DoneForDay = 4,            //
	OrderStatus_Canceled = 5,              //ѳ
	OrderStatus_PendingCancel = 6,         //
	OrderStatus_Stopped = 7,               //
	OrderStatus_Rejected = 8,              //Ѿܾ
	OrderStatus_Suspended = 9,             //
	OrderStatus_PendingNew = 10,           //
	OrderStatus_Calculated = 11,           //
	OrderStatus_Expired = 12,              //ѹ
	OrderStatus_AcceptedForBidding = 13,   //
	OrderStatus_PendingReplace = 14,       //
};

//ִлر
enum ExecType
{
	ExecType_Unknown = 0,
	ExecType_New = 1,                      //ѱ
	ExecType_DoneForDay = 4,               //
	ExecType_Canceled = 5,                 //ѳ
	ExecType_PendingCancel = 6,            //
	ExecType_Stopped = 7,                  //
	ExecType_Rejected = 8,                 //Ѿܾ
	ExecType_Suspended = 9,                //
	ExecType_PendingNew = 10,              //
	ExecType_Calculated = 11,              //
	ExecType_Expired = 12,                 //
	ExecType_Restated = 13,                //
	ExecType_PendingReplace = 14,          //
	ExecType_Trade = 15,                   //ɽ
	ExecType_TradeCorrect = 16,            //
	ExecType_TradeCancel = 17,             //
	ExecType_OrderStatus = 18,             //ί״̬
	ExecType_CancelRejected = 19,          //ܾ
};

//ίоܾԭ
enum OrderRejectReason
{
	OrderRejectReason_Unknown = 0,                           //δ֪ԭ
	OrderRejectReason_RiskRuleCheckFailed = 1,               //Ϸع 
	OrderRejectReason_NoEnoughCash = 2,                      //ʽ
	OrderRejectReason_NoEnoughPosition = 3,                  //λ
	OrderRejectReason_IllegalAccountId = 4,                  //Ƿ˻ID
	OrderRejectReason_IllegalStrategyId = 5,                 //ǷID
	OrderRejectReason_IllegalSymbol = 6,                     //Ƿ״
	OrderRejectReason_IllegalVolume = 7,                     //Ƿί
	OrderRejectReason_IllegalPrice = 8,                      //Ƿίм
	OrderRejectReason_AccountDisabled = 10,                  //˺űֹ
	OrderRejectReason_AccountDisconnected = 11,              //˺δ
	OrderRejectReason_AccountLoggedout = 12,                 //˺δ¼
	OrderRejectReason_NotInTradingSession = 13,              //ǽʱ
	OrderRejectReason_OrderTypeNotSupported = 14,            //ίͲ֧
	OrderRejectReason_Throttle = 15,                         //
	OrderRejectReason_SymbolSusppended = 16,                 //״ͣ
	OrderRejectReason_Internal = 999,                        //ڲ

	CancelOrderRejectReason_OrderFinalized = 101,            //ί
	CancelOrderRejectReason_UnknownOrder = 102,              //δ֪ί
	CancelOrderRejectReason_BrokerOption = 103,              //̨
	CancelOrderRejectReason_AlreadyInPendingCancel = 104,    //ίг
};

//ίз
enum OrderSide
{
	OrderSide_Unknown = 0,
	OrderSide_Buy = 1,    //
	OrderSide_Sell = 2,    //
};

//ί
enum OrderType
{
	OrderType_Unknown = 0,
	OrderType_Limit = 1,    //޼ί
	OrderType_Market = 2,    //мί
	OrderType_Stop = 3,    //ֹֹӯί
};

//ίʱ
enum OrderDuration
{
	OrderDuration_Unknown = 0,
	OrderDuration_FAK = 1,  //ʱɽʣ೷(fill and kill)
	OrderDuration_FOK = 2,  //ʱȫɽ(fill or kill)
	OrderDuration_GFD = 3,  //Ч(good for day)
	OrderDuration_GFS = 4,  //Ч(good for section)
	OrderDuration_GTD = 5,  //ָǰЧ(goodl till date)
	OrderDuration_GTC = 6,  //ǰЧ(good till cancel)
	OrderDuration_GFA = 7,  //ϾǰЧ(good for auction)
};

//ίгɽ
enum OrderQualifier
{
	OrderQualifier_Unknown = 0,
	OrderQualifier_BOC = 1,  //Էż۸(best of counterparty)
	OrderQualifier_BOP = 2,  //ż۸(best of party)
	OrderQualifier_B5TC = 3,  //嵵ʣ೷(best 5 then cancel)
	OrderQualifier_B5TL = 4,  //嵵ʣת޼(best 5 then limit)
};


//ֲַ
enum PositionSide
{
	PositionSide_Unknown = 0,
	PositionSide_Long = 1,   //෽
	PositionSide_Short = 2,   //շ
};

//ƽ־
enum PositionEffect
{
	PositionEffect_Unknown = 0,
	PositionEffect_Open = 1,     //
	PositionEffect_Close = 2,     //ƽ,ȡڶӦĽ
	PositionEffect_CloseToday = 3,     //ƽ
	PositionEffect_CloseYesterday = 4,     //ƽ
};

//ʽֱֲԭ
enum CashPositionChangeReason
{
	CashPositionChangeReason_Unknown = 0,
	CashPositionChangeReason_Trade = 1,  //
	CashPositionChangeReason_Inout = 2,  ///ֲ
	CashPositionChangeReason_Dividend = 3,  //ֺ͹
};

enum AccountState
{
	State_UNKNOWN = 0,       //δ֪
	State_CONNECTING = 1,    //
	State_CONNECTED = 2,     //
	State_LOGGEDIN = 3,      //ѵ¼
	State_DISCONNECTING = 4, //Ͽ
	State_DISCONNECTED = 5,  //ѶϿ
	State_ERROR = 6          //
};

//㷨״̬,ͣ/ָ㷨ʱЧ
enum AlgoOrderStatus 
{
	AlgoOrderStatus_Unknown = 0,
	AlgoOrderStatus_Resume = 1,                  //ָĸ
	AlgoOrderStatus_Pause = 2,                   //ͣĸ
	AlgoOrderStatus_PauseAndCancelSubOrders = 3  //ĸӵ
};


typedef char Symbol[LEN_SYMBOL];
typedef char TradingDate[LEN_ISO_DATATIME];

struct Bar
{
	char                    symbol[LEN_SYMBOL];
	double                  bob;                          ///barĿʼʱ
	double                  eob;                          ///barĽʱ
	float                   open;                         ///<̼
	float                   close;                        ///<̼
	float                   high;                         ///<߼
	float                   low;                          ///<ͼ
	double                  volume;                       ///<ɽ
	double                  amount;                       ///<ɽ
	float                   pre_close;                    ///ֻ̼ۣƵݸֵ

	long long               position;                     ///<ֲ
	char                    frequency[LEN_FREQUENCY];     ///barƵ
};

struct Quote
{
	float      bid_price;                            ///ί
	long long  bid_volume;                           ///ί
	float      ask_price;                            ///ί
	long long  ask_volume;                           ///ί
};

struct Tick
{
	char                   symbol[LEN_SYMBOL];
	double                 created_at;               ///<utcʱ䣬ȷ
	float                  price;                    ///<¼
	float                  open;                     ///<̼
	float                  high;                     ///<߼
	float                  low;                      ///<ͼ
	double                 cum_volume;               ///<ɽ
	double                 cum_amount;               ///<ɽܽ/³ɽ,ۼֵ
	long long              cum_position;             ///<Լֲ(),ۼֵ
	double                 last_amount;              ///<˲ʱɽ
	int                    last_volume;              ///<˲ʱɽ
	int                    trade_type;               ///(),Ӧ࿪,ƽ
	Quote                  quotes[DEPTH_OF_QUOTE];   ///, ±0ʼ0-ʾһ1-ʾڶ

};

struct L2Transaction
{
	char                   symbol[LEN_SYMBOL];
	double                 created_at;               ///ɽʱ䣬utcʱ
	float                  price;                    ///ɽ
	double                 volume;					 ///ɽ
	int                    side;                     ///̱
};


struct Order
{
	char         strategy_id[LEN_ID];                     //ID                                      
	char         account_id[LEN_ID];                      //˺ID                                      
	char         account_name[LEN_NAME];                  //˻¼                                  

	char         cl_ord_id[LEN_ID];                       //ίпͻID                                
	char         order_id[LEN_ID];                        //ίй̨ID                     
	char         ex_ord_id[LEN_ID];                       //ίнID   
	char         algo_order_id[LEN_ID];                   //㷨ĸID

	char         symbol[LEN_SYMBOL];                      //symbol                                      
	int          side;                                    //ȡֵοenum OrderSide            
	int          position_effect;                         //ƽ־ȡֵοenum PositionEffect       
	int          position_side;                           //ֲַȡֵοenum PositionSide         

	int          order_type;                              //ίͣȡֵοenum OrderType            
	int          order_duration;                          //ίʱԣȡֵοenum OrderDuration    
	int          order_qualifier;                         //ίгɽԣȡֵοenum OrderQualifier   
	int          order_src;                               //ίԴȡֵοenum OrderSrc             

	int          status;                                  //ί״̬ȡֵοenum OrderStatus          
	int          ord_rej_reason;                          //ίоܾԭȡֵοenum OrderRejectReason
	char         ord_rej_reason_detail[LEN_INFO];         //ίоܾԭ                            

	double       price;                                   //ίм۸                                    
	double       stop_price;                              //ίֹ/ֹӯ۸                       

	int          order_style;                             //ίзȡֵο enum OrderStyle          
	long long    volume;                                  //ί                                      
	double       value;                                   //ίж                                      
	double       percent;                                 //ίаٷֱ                                  
	long long    target_volume;                           //ίĿ                                  
	double       target_value;                            //ίĿ                                  
	double       target_percent;                          //ίĿٷֱ                              

	long long    filled_volume;                           //ѳ                                      
	double       filled_vwap;                             //ѳɾ                                    
	double       filled_amount;                           //ѳɽ                                    
	double       filled_commission;                       //ѳ                                  

	long long    created_at;                              //ίдʱ                                
	long long    updated_at;                              //ίиʱ  
};

struct AlgoOrder
{
	char         strategy_id[LEN_ID];                     //ID                                      
	char         account_id[LEN_ID];                      //˺ID                                      
	char         account_name[LEN_NAME];                  //˻¼                                  

	char         cl_ord_id[LEN_ID];                       //ίпͻID                                
	char         order_id[LEN_ID];                        //ίй̨ID                                  
	char         ex_ord_id[LEN_ID];                       //ίнID                                

	char         symbol[LEN_SYMBOL];                      //symbol                                      
	int          side;                                    //ȡֵοenum OrderSide            
	int          position_effect;                         //ƽ־ȡֵοenum PositionEffect       
	int          position_side;                           //ֲַȡֵοenum PositionSide         

	int          order_type;                              //ίͣȡֵοenum OrderType            
	int          order_duration;                          //ίʱԣȡֵοenum OrderDuration    
	int          order_qualifier;                         //ίгɽԣȡֵοenum OrderQualifier   
	int          order_src;                               //ίԴȡֵοenum OrderSrc             

	int          status;                                  //ί״̬ȡֵοenum OrderStatus          
	int          ord_rej_reason;                          //ίоܾԭȡֵοenum OrderRejectReason
	char         ord_rej_reason_detail[LEN_INFO];         //ίоܾԭ                            

	double       price;                                   //ίм۸                                    
	double       stop_price;                              //ίֹ/ֹӯ۸                       

	int          order_style;                             //ίзȡֵο enum OrderStyle          
	long long    volume;                                  //ί                                      
	double       value;                                   //ίж                                      
	double       percent;                                 //ίаٷֱ                                  
	long long    target_volume;                           //ίĿ                                  
	double       target_value;                            //ίĿ                                  
	double       target_percent;                          //ίĿٷֱ                              

	long long    filled_volume;                           //ѳ                                      
	double       filled_vwap;                             //ѳɾ                                    
	double       filled_amount;                           //ѳɽ                                    
	double       filled_commission;                       //ѳ     

	char         algo_name[LEN_NAME];                     //㷨
	char         algo_param[LEN_PARAM];                   //㷨Բ
	int          algo_status;                             //㷨״̬,ΪAlgoOrder PauseΣȡֵο enum AlgoOrderStatus
	char         algo_comment[LEN_COMMENT];               //㷨ע

	long long    created_at;                              //ίдʱ                                
	long long    updated_at;                              //ίиʱ  
};

struct AlgoParam 
{
	char              algo_name[LEN_NAME];                 //㷨
	char              time_start[LEN_ISO_DATATIME];        //ʼʱ
	char              time_end[LEN_ISO_DATATIME];          //ʱ
	double            part_rate;                           //ȱ
	int               min_amount;                          //Сίн
};

struct ExecRpt
{
	char               strategy_id[LEN_ID];                  //ID                                                                                                        
	char               account_id[LEN_ID];                   //˺ID                                                       
	char               account_name[LEN_NAME];               //˻¼                                                                                                    

	char               cl_ord_id[LEN_ID];                    //ίпͻID                                                                                                  
	char               order_id[LEN_ID];                     //ίй̨ID                                                                                                    
	char               exec_id[LEN_ID];                      //ίлرID                                                                                                    

	char               symbol[LEN_SYMBOL];                   //symbol                                                                                                        

	int                position_effect;                      //ƽ־ȡֵοenum PositionEffect                                                                         
	int                side;                                 //ȡֵοenum OrderSide                                                                              
	int                ord_rej_reason;                       //ίоܾԭȡֵοenum OrderRejectReason                                                                  
	char               ord_rej_reason_detail[LEN_INFO];      //ίоܾԭ                                                                                              
	int                exec_type;                            //ִлر, ȡֵοenum ExecType                                                                           

	double             price;                                //ίгɽ۸                                                                                                  
	long long          volume;                               //ίгɽ                                                                                                    
	double             amount;                               //ίгɽ                                                                                                  
	double             commission;                           //ίгɽ                                                                                                
	double             cost;                                 //ίгɽɱ  
	long long          created_at;                           //رʱ

};

struct Cash
{
	char          account_id[LEN_ID];                        //˺ID               
	char          account_name[LEN_NAME];                    //˻¼                                                                   

	int           currency;                                  //                                                                         

	double        nav;                                        //ֵ(cum_inout + cum_pnl + fpnl - cum_commission)                            
	double        pnl;                                        //(nav-cum_inout)                                                        
	double        fpnl;                                       //ӯ(sum(each position fpnl))                                            
	double        frozen;                                     //ֲռʽ                                                                 
	double        order_frozen;                               //ҵʽ                                                                 
	double        available;                                  //ʽ                                                                     
															  //no  leverage:  available=(cum_inout + cum_pnl - cum_commission - frozen - order_frozen)        
															  //has leverage:  fpnl     =(fpnl>0 ? fpnl : (frozen < |fpnl|) ? (frozen-|fpnl|) : 0)             
															  //               available=(cum_inout + cum_pnl - cum_commission - frozen - order_frozen + fpnl) 
	double        balance;                                    //ʽ                                                                     

	double        cum_inout;                                  //ۼƳ                                                                   
	double        cum_trade;                                  //ۼƽ׶                                                                   
	double        cum_pnl;                                    //ۼƽ(û۳)                                                   
	double        cum_commission;                             //ۼ                                                                   

	double        last_trade;                                 //һν׶                                                                 
	double        last_pnl;                                   //һ                                                                   
	double        last_commission;                            //һ                                                                 
	double        last_inout;                                 //һγ                                                                 
	int           change_reason;                              //ʽԭȡֵοenum CashPositionChangeReason                          
	char          change_event_id[LEN_ID];                    //ʽ¼ID     

	long long     created_at;                                 //ʽʼʱ
	long long     updated_at;                                 //ʽʱ

};

struct Position
{
	char                 account_id[LEN_ID];              //˺ID                                       
	char                 account_name[LEN_NAME];          //˻¼                                                                                       

	char                 symbol[LEN_SYMBOL];              //symbol                                       
	int                  side;                            //ֲַȡֵοenum PositionSide          
	long long            volume;                          //ֲܳ; ֲ(volume-volume_today)                                                          
	long long            volume_today;                    //ճֲ                                                                                       
	double               vwap;                            //ֲ־                                                                                         
	double               amount;                          //ֲֶ(volume*vwap*multiplier)                                                                   

	double               price;                           //ǰ۸                                                                                     
	double               fpnl;                            //ֲָӯ((price-vwap)*volume*multiplier)                                                     
	double               cost;                            //ֲֳɱ(vwap*volume*multiplier*margin_ratio)                                                    
	long long            order_frozen;                    //ҵλ                                                                                     
	long long            order_frozen_today;              //ҵֲλ                                                                                 
	long long            available;                       //ܲλ(volume-order_frozen); λ(available-available_today)                           
	long long            available_today;                 //ýλ(volume_today-order_frozen_today)
	long long            available_now;                   //ǰƽλ

	double               last_price;                      //һγɽ                                                                                     
	long long            last_volume;                     //һγɽ                                                                                     
	long long            last_inout;                      //һγֲ                                                                                 
	int                  change_reason;                   //λԭȡֵοenum CashPositionChangeReason                                              
	char                 change_event_id[LEN_ID];         //ʽ¼ID                                                                             

	int                  has_dividend;                    //ֲзֺ   
	long long            created_at;                      //ʱ
	long long            updated_at;                      //λʱ

};

struct Account 
{
	char            account_id[LEN_ID];           //˺ID
	char            account_name[LEN_NAME];       //˻¼
	char            title[LEN_NAME];              //˺
	char            intro[LEN_INFO];              //˺
	char            comment[LEN_INFO];            //˺űע
};

struct AccountStatus
{
	char            account_id[LEN_ID];           //˺ID
	char            account_name[LEN_NAME];       //˻¼
	int             state;                        //˻״̬
	int             error_code;                   //
	char            error_msg[LEN_INFO];          //Ϣ
};

struct Parameter
{
	char   key[LEN_ID];          //
	double value;                //ֵ
	double min;                  //õСֵ
	double max;                  //õֵ
	char   name[LEN_NAME];       //
	char   intro[LEN_INFO];      //˵
	char   group[LEN_NAME];      //
	bool   readonly;             //Ƿֻ
};

struct Indicator
{
	char      account_id[LEN_ID];             //˺ID
	double    pnl_ratio;                      //ۼ(pnl/cum_inout)
	double    pnl_ratio_annual;               //껯
	double    sharp_ratio;                    //ձ
	double    max_drawdown;                   //س
	double    risk_ratio;                     //ձ
	int       open_count;                     //ִ
	int       close_count;                    //ƽִ
	int       win_count;                      //ӯ
	int       lose_count;                     //
	double    win_ratio;                      //ʤ

	long long  created_at;                    //ָ괴ʱ
	long long  updated_at;                    //ָʱ
};


#endif
